/**
 * PETALS - PETALS Services Platform. Copyright (c) 2009 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */
package org.ow2.petals.commons.exception;

/**
 * @author rnaudin
 *
 */
public class ExceptionUtil {
    
    /**
     * Get an extends error message, which is an aggregation of causes messages or types if the message is null.
     */
    public static final String getExtendedMessage(final Exception exception) {
        Throwable _exception = exception;
        final StringBuilder msg = new StringBuilder();
        if (_exception.getMessage() != null) {
            msg.append(_exception.getMessage());
        } else {
            msg.append(_exception.getClass().getSimpleName());
        }
        
        while (_exception.getCause() != null) {
            _exception = _exception.getCause();
            msg.append("\nCaused by: ");
            if (_exception.getMessage() != null) {
                msg.append(_exception.getMessage());
            } else {
                msg.append(_exception.getClass().getSimpleName());
            }
        }
        
        return msg.toString();
    }

}
